PROGRAM main

    USE types_module
    !     USE ifport
    USE tools_module

    IMPLICIT NONE
    REAL(dp), DIMENSION(9)                      ::  inputpar 			!Number of parameters for normal mixture
    INTEGER, DIMENSION(1)                       ::  temp                !number of cardinalities of the state space
    INTEGER                                     ::  iter                ! number of iterations for amoeba to find a minimum
    REAL(dp)                                    ::  ftol,weight
    INTEGER, PARAMETER                          ::  t=1000000           ! number of realizations of the continuous process
    REAL(dp), DIMENSION(t)                      ::  process             ! the realizations of the continuous process
    INTEGER                                     ::  n                   ! number of states used for the discrete approximation
    REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  transition          ! the transition matrix of the approximating markov process
    REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  states
    REAL(dp), DIMENSION(:), ALLOCATABLE         ::  yy
    REAL(dp), DIMENSION(100)                    ::  best				
    REAL(dp), DIMENSION(9)                      ::  Targets             ! the vector of moments
    INTEGER                                     ::  i,j,k,h,ii             ! counter
    REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  RandomRestarts      ! vector to store initial random simplex for random restarts    
    INTEGER                                     ::  clock_start,clock_end,clock_rate
    REAL(dp)                                    ::  elapsed_time
    CHARACTER(2)                                ::  name
    REAL(dp), DIMENSION(9)                      ::  detail             ! the vector of moments
    REAL(dp)                                    ::  temp1,minpro,maxpro,start, finish
    CHARACTER(4)                                ::  stopcond
	REAL(dp)  									::  std_y, weight_tau, weighted_std_tau
	REAL(dp), DIMENSION(9)						::  grid_y
	INTEGER 									::  hh,info
    CHARACTER(3)                                ::  s2
    CHARACTER(5)                                ::  s1
	REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  Results_vector,states_vector 


    ! specify the normal mixture
    
    inputpar(1)=0.00_dp          ! mean1    
    inputpar(2)=1_dp          ! variance1
    inputpar(3)=0.00_dp          ! mean2    
    inputpar(4)=inputpar(2)          ! variance2
    inputpar(5)=0.0_dp          ! mean3    
    inputpar(6)=inputpar(2)          ! variance3
    inputpar(7)=1.0_dp      ! p1       
    inputpar(8)=0.0_dp    ! p2       
    inputpar(9)=0.865_dp           ! rho      
    
	WRITE(s1,'(F5.3)')inputpar(9)
    s2=s1(3:5)
	
    ! specify the cardinality of the state space
    ! if you want to try with several different cardinality
    ! for example 3 and 5, make t of dimension 2 and specify
    ! temp=(/3,5/)
    
    temp=(/9/)
	
    
    k=1000
    
    ! computing the moments from the continuous process
    Targets=ParToMom(inputpar)
    ! The process is simulated to print
    ! the moments of the differences
    CALL process2(inputpar,process)
	CALL dlasrt('I',t,process,info)
  
    whatmoments(1)=0.0_dp      ! mean of process
    whatmoments(2)=1.0_dp      ! variance of process
    whatmoments(3)=0.0_dp      ! skeweness of process
    whatmoments(4)=1.0_dp      ! kurtosis of process
    whatmoments(5)=0.0_dp      ! mean of e
    whatmoments(6)=1.0_dp      ! variance of e
    whatmoments(7)=0.0_dp      ! skeweness of e
    whatmoments(9)=1.0_dp      ! kurtosis of e
    whatmoments(8)=1.0_dp      ! rho

    
    
    PRINT'(A31,F6.2,F6.2)','           mean of the process ',Targets(1)
    PRINT'(A31,F6.2,F6.2)','       variance of the process ',Targets(2)
    PRINT'(A31,F6.2,F6.2)','       skewness of the process ',Targets(3)
    PRINT'(A31,F6.2,F6.2)','       kurtosis of the process ',Targets(4)     
    PRINT'(A31,F6.2,F6.2)','                 mean of the e ',Targets(5)
    PRINT'(A31,F6.2,F6.2)','             variance of the e ',Targets(6)
    PRINT'(A31,F6.2,F6.2)','             skewness of the e ',Targets(7)
    PRINT'(A31,F6.2,F6.2)','             kurtosis of the e ',Targets(8)
    PRINT'(A31,F6.2,F6.2)','                           rho ',Targets(9)
    
    minpro=0_dp
    !maxpro=3.0_dp*Targets(2)**0.5_dp
    !print*,maxpro
    center=0_dp
    DO ii=1,size(temp)
        j=temp(ii)
        CALL SYSTEM_CLOCK(COUNT_RATE=clock_rate)
        CALL SYSTEM_CLOCK(COUNT=clock_start)
        n=j
		
        IF (n .LE. 15) THEN
            maxpro=process(90*t/100)
        ELSE
            maxpro=process(99*t/100)
        END IF
		
		
        IF (MOD(n,2) .EQ. 0) THEN ! if n is even
			start=0.0_dp
			CALL CPU_TIME(start)
          	
            ALLOCATE(RandomRestarts(n/2+1,n/2))
            ALLOCATE(states(n/2+1,n/2))
            ALLOCATE(yy(n/2+1))
            ALLOCATE(transition(n,n))
			ALLOCATE(Results_vector(2*k/100,4)) 
			ALLOCATE(states_vector(2*k/100,n/2))
			
            best(n/2+1)=1000.0_dp
			ftol=10.0_dp**(-6.0_dp)
            DO h=1,k
                OPEN(UNIT=2,FILE='stop')
                READ(2,'(A4)') stopcond
                CLOSE(2)
                IF (stopcond .EQ. 'stop') EXIT
                RandomRestarts(:,:)=RandomSimplex(n/2,minpro,maxpro)
                states=RandomRestarts(:,:)
                DO i=1,n/2+1 
                    yy(i)=ErrorFunction2even(inputpar,targets,states(i,:))
                END DO    
                
                CALL amoeba1even(states,yy,ftol,iter,inputpar,targets)
                IF (best(n/2+1) .GT. yy(1)) THEN
                    best(1:n/2)=states(1,:)
                    best(n/2+1)=yy(1)
                END IF
				! every 100 restarts print the results of the global
				! optimization
				IF (MOD(h,100) .EQ. 0) THEN
					finish=0.0_dp
					CALL CPU_TIME(finish)
					temp1=PerErroreven(inputpar,targets,best(1:n/2),detail)
					Results_vector(h/100,1)=REAL(h)
					Results_vector(h/100,2)=best(n/2+1)
					Results_vector(h/100,3)=temp1
					Results_vector(h/100,4)=finish-start
					states_vector(h/100,:)=best(1:n/2)	
					PRINT'(F12.1,2F15.8,F15.1)', Results_vector(h/100,:)	
				END IF		
				
            END DO
        
							
            DO h=1,k
                OPEN(UNIT=2,FILE='stop')
                READ(2,'(A4)') stopcond
                CLOSE(2)
                IF (stopcond .EQ. 'stop') EXIT   
                RandomRestarts(:,:)=RandomSimplex(n/2,minpro,maxpro)        
                weight=(real(k-h+1)/real(k))
                DO i=1,n/2+1
                    states(i,:)=RandomRestarts(i,:)*weight+best(1:n/2)*(1.0-weight)
                END DO
                DO i=1,n/2+1 
                    yy(i)=ErrorFunction2even(inputpar,targets,states(i,:))
                END DO    
                CALL amoeba1even(states,yy,ftol,iter,inputpar,targets)
                IF (best(n/2+1) .GT. yy(1)) THEN
                    best(1:n/2)=states(1,:)
                    best(n/2+1)=yy(1)					
                END IF
				! every 100 restarts print the results of the global
				! optimization
				IF (MOD(h,100) .EQ. 0) THEN
					finish=0.0_dp
					CALL CPU_TIME(finish)
					temp1=PerErroreven(inputpar,targets,best(1:n/2),detail)
					Results_vector((k+h)/100,1)=REAL(h)
					Results_vector((k+h)/100,2)=best(n/2+1)
					Results_vector((k+h)/100,3)=temp1
					Results_vector((k+h)/100,4)=finish-start
					states_vector((k+h)/100,:)=best(1:n/2)	
					PRINT'(F12.1,2F15.8,F15.1)', Results_vector((k+h)/100,:)	
				END IF		
            END DO
            CALL SYSTEM_CLOCK(COUNT=clock_end)
            elapsed_time=REAL(clock_end-clock_start)/REAL(clock_rate)
			WRITE (name,'(I2)') n
	        OPEN(unit=7,file='criteria_iter'//name//'_'//s2)
			OPEN(unit=9,file='states_iter'//name//'_'//s2)
			WRITE(7,'(A12,2A15,A15)') 'No of iter','criteria','percent dev','time'
			DO i=1,2*k/100
				WRITE(7,'(F12.1,2F15.8,F15.1)') Results_vector(i,:)		
				WRITE(9,'('//name//'F11.5)') states_vector(i,1:n/2)
			END DO
	        OPEN(unit=1,file='results'//name//'_'//s2)
			
	
            WRITE(1,*) "number of states"
            WRITE(1,'(I5)') n
            WRITE(1,*) ""       
            WRITE(1,*) "time elapsed: "
            WRITE(1,'(F9.3)') elapsed_time
            WRITE(1,*) ""       
            WRITE(1,*) "criterion: "
            WRITE(1,'(F9.3)') best(n/2+1)
            WRITE(1,*) ""       
            temp1=PerErroreven(inputpar,targets,best(1:n/2),detail)
            WRITE(1,*) "percentage criterion"
            WRITE(1,'(F9.3)') temp1
            WRITE(1,*) ""  
			WRITE(1,*) ""        
	        WRITE(1,'(A31,A12,A10)') " detailed percentage criterion  ","perc. dev","target"
	        WRITE(1,'(A31,F12.4,F10.3)') ' mean of the process            ',detail(1),Targets(1)
	        WRITE(1,'(A31,F12.4,F10.3)') ' variance of the process        ',detail(2),Targets(2)
	        WRITE(1,'(A31,F12.4,F10.3)') ' skewness of the process        ',detail(3),Targets(3)
	        WRITE(1,'(A31,F12.4,F10.3)') ' kurtosis of the process        ',detail(4),Targets(4)
	        WRITE(1,'(A31,F12.4,F10.3)') ' mean of the error              ',detail(5),Targets(5)
	        WRITE(1,'(A31,F12.4,F10.3)') ' variance of the error          ',detail(6),Targets(6)
	        WRITE(1,'(A31,F12.4,F10.3)') ' skewness of the error          ',detail(7),Targets(7)
	        WRITE(1,'(A31,F12.4,F10.3)') ' kurtosis of the error          ',detail(8),Targets(8)
	        WRITE(1,'(A31,F12.4,F10.3)') ' autocorrelation of the process ',detail(9),Targets(9)
            WRITE(1,*) ""       
            WRITE(1,*) "states"
            WRITE(1,'(F9.3)') (/2.0_dp*center-best(n/2:1:-1),best(1:n/2)/)
            CALL TransitionOneStep(inputpar,(/2.0_dp*center-best(n/2:1:-1),best(1:n/2)/),transition)
			WRITE(1,*) ""  
	        WRITE(1,*) "transition prob"
            write(1,'('//name//'F9.3)') TRANSPOSE(transition)		
			WRITE(1,*) ""  
			WRITE(1,*) "stationary prob"
			WRITE(1,'('//name//'F9.3)') stationary(transition)
            CLOSE(1)
			CLOSE(7)
			CLOSE(9)		
            DEALLOCATE(RandomRestarts)
            DEALLOCATE(transition)
            DEALLOCATE(states)
            DEALLOCATE(yy)
			DEALLOCATE(Results_vector) 
			DEALLOCATE(states_vector)
			
			
			
        ELSE ! if n is odd
			start=0.0_dp
			CALL CPU_TIME(start)
            ALLOCATE(RandomRestarts((n-1)/2+1,(n-1)/2))
            ALLOCATE(states((n-1)/2+1,(n-1)/2))
            ALLOCATE(yy((n-1)/2+1))
            ALLOCATE(transition(n,n))
			ALLOCATE(Results_vector(2*k/100,4)) 
			ALLOCATE(states_vector(2*k/100,(n-1)/2))
			
            best((n-1)/2+1)=1000.0_dp
			ftol=10.0_dp**(-1.0_dp)
            DO h=1,k
                OPEN(UNIT=2,FILE='stop')
                READ(2,'(A4)') stopcond
                CLOSE(2)
                IF (stopcond .EQ. 'stop') EXIT                
                RandomRestarts(:,:)=RandomSimplex((n-1)/2,minpro,maxpro)
                states=RandomRestarts(:,:)
                DO i=1,(n-1)/2+1 
                    yy(i)=ErrorFunction2odd(inputpar,targets,states(i,:))
                END DO    
                
                CALL amoeba1odd(states,yy,ftol,iter,inputpar,targets)
                IF (best((n-1)/2+1) .GT. yy(1)) THEN
                    best(1:(n-1)/2)=states(1,:)
                    best((n-1)/2+1)=yy(1)
                END IF
				! every 100 restarts print the results of the global
				! optimization
				IF (MOD(h,100) .EQ. 0) THEN
					finish=0.0_dp
					CALL CPU_TIME(finish)		
					temp1=PerErrorOdd(inputpar,targets,best(1:(n-1)/2),detail)
					Results_vector(h/100,1)=REAL(h)
					Results_vector(h/100,2)=best((n-1)/2+1)
					Results_vector(h/100,3)=temp1
					Results_vector(h/100,4)=finish-start
					states_vector(h/100,:)=best(1:(n-1)/2)	
					PRINT'(F12.1,2F15.8,F15.1)', Results_vector(h/100,:)	
				END IF	
				
            END DO
           
            DO h=1,k
                OPEN(UNIT=2,FILE='stop')
                READ(2,'(A4)') stopcond
                CLOSE(2)
                IF (stopcond .EQ. 'stop') EXIT 
                RandomRestarts(:,:)=RandomSimplex((n-1)/2,minpro,maxpro)        
                weight=(real(k-h+1)/real(k))
                DO i=1,(n-1)/2+1
                    states(i,:)=RandomRestarts(i,:)*weight+best(1:(n-1)/2)*(1.0-weight)
                END DO
                DO i=1,(n-1)/2+1 
                    yy(i)=ErrorFunction2odd(inputpar,targets,states(i,:))
                END DO    
                CALL amoeba1odd(states,yy,ftol,iter,inputpar,targets)
                IF (best((n-1)/2+1) .GT. yy(1)) THEN
	                best(1:(n-1)/2)=states(1,:)
	                best((n-1)/2+1)=yy(1)
                END IF
				! every 100 restarts print the results of the global
				! optimization
				IF (MOD(h,100) .EQ. 0) THEN
					finish=0.0_dp
					CALL CPU_TIME(finish)		
					temp1=PerErrorOdd(inputpar,targets,best(1:(n-1)/2),detail)
					Results_vector((k+h)/100,1)=REAL(h)
					Results_vector((k+h)/100,2)=best((n-1)/2+1)
					Results_vector((k+h)/100,3)=temp1
					Results_vector((k+h)/100,4)=finish-start
					states_vector((k+h)/100,:)=best(1:(n-1)/2)	
					PRINT'(F12.1,2F15.8,F15.1)', Results_vector((k+h)/100,:)	
				END IF	
            END DO
			
            CALL SYSTEM_CLOCK(COUNT=clock_end)
            elapsed_time=REAL(clock_end-clock_start)/REAL(clock_rate)
			WRITE (name,'(I2)') n
	        OPEN(unit=7,file='criteria_iter'//name//'_'//s2)
			OPEN(unit=9,file='states_iter'//name//'_'//s2)
			WRITE(7,'(A12,2A15,A15)') 'No of iter','criteria','percent dev','time'
			DO i=1,2*k/100
				WRITE(7,'(F12.1,2F15.8,F15.1)') Results_vector(i,:)		
				WRITE(9,'('//name//'F11.5)') states_vector(i,1:n/2)
			END DO
	        OPEN(unit=1,file='results'//name//'_'//s2)
            WRITE(1,*) "number of states"
            WRITE(1,'(I5)') n
            WRITE(1,*) ""       
            WRITE(1,*) "time elapsed: "
            WRITE(1,'(F9.3)') elapsed_time
            WRITE(1,*) ""       
            WRITE(1,*) "criterion: "
            WRITE(1,'(F9.3)') best((n-1)/2+1)
            WRITE(1,*) ""       
            temp1=PerErrorOdd(inputpar,targets,best(1:(n-1)/2),detail)
            WRITE(1,*) "percentage criterion"
            WRITE(1,'(F9.3)') temp1
            WRITE(1,*) ""       
	        WRITE(1,'(A31,A12,A10)') " detailed percentage criterion  ","perc. dev","target"
	        WRITE(1,'(A31,F12.4,F10.3)') ' mean of the process            ',detail(1),Targets(1)
	        WRITE(1,'(A31,F12.4,F10.3)') ' variance of the process        ',detail(2),Targets(2)
	        WRITE(1,'(A31,F12.4,F10.3)') ' skewness of the process        ',detail(3),Targets(3)
	        WRITE(1,'(A31,F12.4,F10.3)') ' kurtosis of the process        ',detail(4),Targets(4)
	        WRITE(1,'(A31,F12.4,F10.3)') ' mean of the error              ',detail(5),Targets(5)
	        WRITE(1,'(A31,F12.4,F10.3)') ' variance of the error          ',detail(6),Targets(6)
	        WRITE(1,'(A31,F12.4,F10.3)') ' skewness of the error          ',detail(7),Targets(7)
	        WRITE(1,'(A31,F12.4,F10.3)') ' kurtosis of the error          ',detail(8),Targets(8)
	        WRITE(1,'(A31,F12.4,F10.3)') ' autocorrelation of the process ',detail(9),Targets(9)
            WRITE(1,*) ""   
            WRITE(1,*) "states"
            WRITE(1,'(F9.3)') (/2.0_dp*center-best((n-1)/2:1:-1),center,best(1:(n-1)/2)/)  
            CALL TransitionOneStep(inputpar,(/2.0_dp*center-best((n-1)/2:1:-1),center,best(1:(n-1)/2)/) ,transition)
			WRITE(1,*) "" 
			WRITE(1,*) "transition prob"
            write(1,'('//name//'F9.3)') TRANSPOSE(transition)
			WRITE(1,*) ""  
			WRITE(1,*) "stationary prob"
            write(1,'('//name//'F9.3)') stationary(transition)
            CLOSE(1)
			CLOSE(7)
			CLOSE(9)		
            DEALLOCATE(RandomRestarts)
            DEALLOCATE(transition)
            DEALLOCATE(states)
            DEALLOCATE(yy)
			DEALLOCATE(Results_vector) 
			DEALLOCATE(states_vector)
        END IF
    END DO
    CLOSE(1)
END PROGRAM




! what i want to fix or improve in this code
! - the min and max of search must change with the cardinality of the approximation
!     as a higher caridinality typically requires a bigger search area
! - i should try to find a more efficient way of looking for the minimum
!     maybe a sequential bisection approach, where states are added one by one